/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package ic3.portlets.home.component;

import java.util.List ;
import org.exoplatform.container.SessionContainer;
import org.exoplatform.portal.session.ExoPortal ;
import org.exoplatform.faces.core.component.UICommandPortlet ;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.faces.core.renderer.html.BorderDecorator ;
import org.exoplatform.services.communication.message.*;
import org.exoplatform.services.portal.model.Node;
/**
 * Wed, Dec 22, 2003 @ 23:14
 * @author: Tuan Nguyen
 * @email: tuan08@users.sourceforge.net
 * @version: $Id: UIHomePortlet.java,v 1.1 2004/10/27 03:04:10 tuan08 Exp $
 */
public class UIHomePortlet extends UICommandPortlet {
  public final static String SHOW_MESSAGE_CENTER_ACTION =  "showMessageCenter" ;
  public final static String SHOW_LAB_RESULT_ACTION =  "showLabResult" ;
  public final static String SHOW_SYMPTOMS_ACTION =  "showSymptoms" ;
  
  public final static Parameter[] SHOW_MESSAGE_CENTER = { new Parameter(ACTION , SHOW_MESSAGE_CENTER_ACTION) } ;
  public final static Parameter[] SHOW_LAB_RESUTL = { new Parameter(ACTION , SHOW_LAB_RESULT_ACTION ) } ;
  public final static Parameter[] SHOW_SYMPTOMS = { new Parameter(ACTION , SHOW_SYMPTOMS_ACTION) } ;
  
	private MessageService mservice_ ;
  private String user_ ;
  private int newMessage_ ;
  
	public UIHomePortlet(MessageService mservice) throws Exception {
    setId("UIHomePortlet") ;
		setClazz("UIHomePortlet");
    setRendererType("HomePortletRenderer");
    setDecorator(new BorderDecorator("ic3-border")) ;
    mservice_  = mservice ;
    user_ = SessionContainer.getInstance().getOwner() ;
    checkNewMessage() ;
    addActionListener(ShowMessageCenterActionListener.class, SHOW_MESSAGE_CENTER_ACTION) ;
    addActionListener(ShowLabResultActionListener.class, SHOW_LAB_RESULT_ACTION) ;
    addActionListener(ShowSymptomsActionListener.class, SHOW_SYMPTOMS_ACTION) ;
	}
  
  public int getNewMessages() {  
    return newMessage_  ;
  }
  
  public int getNewLabResults() {
    return 0 ;
  }
  
  private void checkNewMessage() throws Exception {
    List accounts = mservice_.getAccounts(user_) ;
    if(accounts.size() == 0 ) {
      newMessage_ = 0 ;
    } else  {
      Account account = (Account) accounts.get(0) ;
      mservice_.synchronizeAccount(account) ;
      newMessage_ = mservice_.countNewMessages(account) ;
    } 
  }
  
  public String getFamily() { return "ic3.portlets.home.component.UIHomePortlet" ;  }
  
  static public class ShowMessageCenterActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      ExoPortal pinfo = (ExoPortal) SessionContainer.getComponent(ExoPortal.class) ;
      Node node = pinfo.getRootNode().findNode("/home/message-center") ;
      pinfo.setSelectedNode(node) ;
    }
  }
  
  static public class ShowLabResultActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      ExoPortal pinfo = (ExoPortal) SessionContainer.getComponent(ExoPortal.class) ;
      Node node = pinfo.getRootNode().findNode("/home/lab-results") ;
      pinfo.setSelectedNode(node) ;
    }
  }
  
  static public class ShowSymptomsActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      ExoPortal pinfo = (ExoPortal) SessionContainer.getComponent(ExoPortal.class) ;
      Node node = pinfo.getRootNode().findNode("/home/my-symptoms") ;
      pinfo.setSelectedNode(node) ;
    }
  }
}
