/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package ic3.sample.test;


import ic3.sample.HelloWorld;
import ic3.sample.MyService;
import ic3.sample.model.Patient;
import junit.framework.TestCase;
import org.exoplatform.container.PortalContainer;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Sep 1, 2004
 * @version $Id: TestSampleService.java,v 1.1 2004/09/30 18:06:04 tuan08 Exp $
 */
public class TestSampleService extends TestCase {
  static private MyService service_ ;
  private HelloWorld hello ;
  
  public void setUp() throws Exception {
    if (service_ == null) {
      PortalContainer container = PortalContainer.getInstance() ;
      service_ = (MyService) container.getComponentInstanceOfType(MyService.class);
    }
  }
  
  public void testHelloWorld() throws Exception {
    PortalContainer container = PortalContainer.getInstance() ;
    hello = (HelloWorld) container.getComponentInstanceOfType(HelloWorld.class);
    hello.sayHello() ;
    service_.doMyService() ;
  }
  
  public void testFindPatient() throws Exception {
    Patient patient = service_.findPatientByName("aname") ;
    assertTrue("Name is not null", patient != null) ;
  }
  
  public void testGetPatients() throws Exception {
    java.util.List list = service_.getPatients() ;
    assertEquals("Expect 100 patients" , 100, list.size()) ;
  }
}
