/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.portal;

import org.exoplatform.test.web.WebUnitSuite;
import org.exoplatform.test.web.unit.ClickLink;
import org.exoplatform.test.web.validator.ExpectTextValidator;

/**
 * May 21, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: DemoPortletsSuite.java,v 1.1 2004/10/11 23:27:28 tuan08 Exp $
 **/
public class DemoPortletsSuite extends WebUnitSuite {
  
  public DemoPortletsSuite(String path) {
    super("DemoPortletsSuite", "Go to Demo section and try to browse all the demo portlet") ;
    goToPage(path) ;
    // Test JSF bridge demo
    addWebUnit(
        new ClickLink("ClickTechnologyBridges", "Click Technology bridge page").
        setTextLink("Technology bridges")
    );
    addWebUnit(
        new ClickLink("ClickJSFBridge", "Click jsf bridge portlet page").
        setTextLink("JSF bridge").
        addValidator(new ExpectTextValidator("Choose Your Preferred Locale From the Map"))
    );
    //  Test Struts bridge demo
    addWebUnit(
        new ClickLink("ClickStrutesBridge", "Click struts bridge portlet page").
        setTextLink("Struts bridge").
        addValidator(new ExpectTextValidator("MailReader Demonstration Application Options"))
    );
    //  Test velocity bridge demo
    addWebUnit(
        new ClickLink("ClickVelocityBridge", "Click velocity bridge portlet page").
        setTextLink("Velocity bridge").
        addValidator(new ExpectTextValidator(" This is a simple demo of a Forum board built with"))
    );
  }
}